package ch.fritteli.labyrinth.generator.renderer.text;

import ch.fritteli.labyrinth.generator.model.Labyrinth;
import ch.fritteli.labyrinth.generator.renderer.Renderer;
import lombok.NonNull;

public class TextRenderer implements Renderer<String> {
    private boolean renderSolution;

    private TextRenderer() {
        this.renderSolution = false;
    }

    @NonNull
    public static TextRenderer newInstance() {
        return new TextRenderer();
    }

    @NonNull
    public TextRenderer setRenderSolution(final boolean renderSolution) {
        this.renderSolution = renderSolution;
        return this;
    }

    @NonNull
    @Override
    public String render(@NonNull final Labyrinth labyrinth) {
        if (labyrinth.getWidth() == 0 || labyrinth.getHeight() == 0) {
            return "";
        }
        final Generator generator = new Generator(labyrinth, this.renderSolution);
        final StringBuilder sb = new StringBuilder();
        while (generator.hasNext()) {
            sb.append(generator.next());
        }
        return sb.toString();
    }

}
