package ch.fritteli.labyrinth.generator.model;

import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;
import static org.assertj.core.api.Assertions.assertThatExceptionOfType;

class LabyrinthTest {
    @Test
    void testConstruct() {
        // act / assert on simple cases
        assertThatExceptionOfType(IllegalArgumentException.class).isThrownBy(() -> new Labyrinth(0, 0))
                .withMessage("width and height must be >1");
        assertThatExceptionOfType(IllegalArgumentException.class).isThrownBy(() -> new Labyrinth(0, 0, 0))
                .withMessage("width and height must be >1");

        // now for the real work:
        // arrange
        final Labyrinth sut = new Labyrinth(2, 3, 5);

        // assert
        assertThat(sut)
                .returns(2, Labyrinth::getWidth)
                .returns(3, Labyrinth::getHeight)
                .returns(5L, Labyrinth::getRandomSeed)
                .returns(new Position(0, 0), Labyrinth::getStart)
                .returns(new Position(1, 2), Labyrinth::getEnd);
    }
}
