package ch.fritteli.labyrinth.generator.model;

import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class PositionTest {
    @Test
    void move() {
        // arrange
        final Position sut = new Position(0, 0);

        // act
        final Position resultTOP = sut.move(Direction.TOP);
        final Position resultRIGHT = sut.move(Direction.RIGHT);
        final Position resultBOTTOM = sut.move(Direction.BOTTOM);
        final Position resultLEFT = sut.move(Direction.LEFT);

        // assert
        // Original is unchanged
        assertThat(sut).isEqualTo(new Position(0, 0));
        assertThat(resultTOP).isEqualTo(new Position(0, -1));
        assertThat(resultRIGHT).isEqualTo(new Position(1, 0));
        assertThat(resultBOTTOM).isEqualTo(new Position(0, 1));
        assertThat(resultLEFT).isEqualTo(new Position(-1, 0));
    }
}
