package ch.fritteli.labyrinth.generator.serialization;

import ch.fritteli.labyrinth.generator.model.Labyrinth;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class SerializerDeserializerTest {
    @Test
    void testSerializeDeserializeTiny() {
        final Labyrinth expected = new Labyrinth(2, 2, 255);
        final byte[] bytes = SerializerDeserializer.serialize(expected);
        final Labyrinth result = SerializerDeserializer.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }

    @Test
    void testSerializeDeserializeMedium() {
        final Labyrinth expected = new Labyrinth(20, 20, -271828182846L);
        final byte[] bytes = SerializerDeserializer.serialize(expected);
        final Labyrinth result = SerializerDeserializer.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }

    @Test
    void testSerializeDeserializeLarge() {
        final Labyrinth expected = new Labyrinth(200, 320, 3141592653589793238L);
        final byte[] bytes = SerializerDeserializer.serialize(expected);
        final Labyrinth result = SerializerDeserializer.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }
}
